//
//	Copyright (c) 1998 Qualis Design Corporation.
//	All rights reserved.
//
//	Qualis Design Corporation
//	PO Box 4444
//	Beaverton OR 97075-4444
//	Phone: +1-503-670-7200
//	E-mail: info@qualis.com
//	World Wide Web: http://www.qualis.com	
//

module MODEL;

reg R;

//
// Waveform generator
//
initial
begin
   # 2 R = 1;
   #11 R = 0;
   #11 R = 1;
   # 9 R = 0;
   # 3 R = 1;
   # 3 R = 0;
   # 2 R = 1;
   # 2 R = 0;
   # 2 R = 1;
   # 2 R = 0;
   #20 $finish;
end

//
// Samplers
//
reg S1;
always @ (R)
begin
   S1 = #10 R;
end

reg S2;
always @ (R)
begin
   #10 S2 = R;
end

reg S3;
always @ (R)
begin
   S3 <= #10 R;
end

wire S4;
assign #10 S4 = R;

always @ (R or S1 or S2 or S3 or S4)
begin
   $write("%b%b%b%b%b at %0d\n", R, S1, S2, S3, S4, $time);
end

endmodule
