//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

module DESIGN;

reg POP, PUSH;
reg [7:0] NEW;
wire [7:0] TOS;

//
// Stack
//
STACK PILE(POP, PUSH, NEW, TOS);


//
// Test the stack operation
//
reg [7:0] DATA [3:0];
reg [7:0] TMP;
integer j, k;
initial
begin
   
   // Initialize the test pattern
   DATA[0] = 8'hAA;
   DATA[1] = 8'h55;
   DATA[2] = 8'hF0;
   DATA[3] = 8'h0F;

   POP = 1'b0;
   PUSH = 1'b0;
   #10;

   // Test with increasing number of data
   for (j = 0; j < 4; j = j + 1) begin
      for (k = 0; k <= j; k = k + 1) begin
         DO_PUSH(DATA[k]);   
      end
      for (k = j; k >= 0; k = k - 1) begin
         DO_POP(TMP);
         if (TMP !== DATA[k]) begin
            $write("ERROR (%0d/%0d): TOS value is %h instead of %h\n",
                   j, k, TMP, DATA[k]);
         end
      end
   end

   $write("Test completed\n");
   $finish;
end


task DO_POP;
   output [7:0] PDAT;
begin
   POP = 1'b1;
   #10;
   PDAT = TOS;
   POP = 1'b0;
   #10;
end
endtask

task DO_PUSH;
   input [7:0] PDAT;
begin
   PUSH = 1'b1;
   NEW  = PDAT;
   #10;
   PUSH = 1'b0;
   #10;
end
endtask

endmodule
