//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//
module STACK(POP, PUSH, DATA);
input        POP, PUSH;
inout  [7:0] DATA;

//
// Stack
//
reg [7:0] THE_STACK [3:0];
integer i;
always @ (negedge POP or posedge PUSH)
begin
   if (PUSH == 1'b1) begin
      for (i = 3; i > 0; i = i - 1) THE_STACK[i] = THE_STACK[i-1];
      THE_STACK[0] = DATA;
   end
   else if (POP == 1'b0) begin
      for (i = 0; i < 3; i = i + 1) THE_STACK[i] = THE_STACK[i+1];
   end
end
assign DATA = (POP == 1'b1) ? THE_STACK[0] : 8'hZZ;

endmodule