//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

`timescale 1ps/1ps
module TESTINV;

reg I;
wire O;

INVERTER DUT(I, O);

real STAMP;
reg [9:0] i;
initial
begin
   $timeformat(-9, 3, " ns", 8);

   I = 1'b0;
   #100;

   // Identify the rise/fall delay
   STAMP = $realtime;
   I = 1'b1;
   @ (negedge O);
   $write("Fall delay = %t\n", $realtime - STAMP);
   
   STAMP = $realtime;
   I = 1'b0;
   @ (posedge O);
   $write("Rise delay = %t\n", $realtime - STAMP);

   $write("Running several events to benchmark simulation.\n");
   $write("Working...");

   i = 0;
   repeat (25000) begin
      if (i == 0) $write("X...");
      i = i + 1;
      I = 1'b1; @ (negedge O);
      I = 1'b0; @ (posedge O);
   end
   $write("Done.\n");

   $finish;
end

endmodule
