//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

module STACK(POP, PUSH, DATA);

parameter
   WIDTH = 8,
   DEPTH = 4;

input            POP, PUSH;
inout  [WIDTH:1] DATA;

//
// Stack
//
reg [WIDTH:1] THE_STACK [DEPTH:1];
integer i;
always @ (negedge POP or posedge PUSH)
begin
   if (PUSH == 1'b1) begin
      for (i = DEPTH; i > 1; i = i - 1) THE_STACK[i] = THE_STACK[i-1];
      THE_STACK[1] = DATA;
   end
   else if (POP == 1'b0) begin
      for (i = 1; i < DEPTH; i = i + 1) THE_STACK[i] = THE_STACK[i+1];
   end
end
assign DATA = (POP == 1'b1) ? THE_STACK[1] : {WIDTH{1'bz}};

endmodule