//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

`timescale 1ns/1ns
module TESTINV;

reg I;
wire O;

INVERTER DUT(I, O);

defparam
   DUT.RISE = 4.5,
   DUT.FALL = 1.6;

real STAMP;
reg [9:0] i;
initial
begin
   $timeformat(-9, 3, " ns", 8);

   I = 1'b0;
   #100;

   // Identify the rise/fall delay
   STAMP = $realtime;
   I = 1'b1;
   @ (negedge O);
   $write("Fall delay = %t\n", $realtime - STAMP);
   
   STAMP = $realtime;
   I = 1'b0;
   @ (posedge O);
   $write("Rise delay = %t\n", $realtime - STAMP);

   $finish;
end

endmodule
