//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

module TEST_RFILE;

reg  [3:0] A, B;
wire [3:0] O;
reg  [2:0] ADDR;

RFILE DUT(A, B, ADDR, O);

integer i;
reg [6:0] j;
initial
begin

   // Perform the test several times to get a good
   // comparative performance result
   $write("Testing entire address space several times...\n");
   j = 0;
   repeat (10000) begin
      if (j == 0) $write("X...");
      j = j + 1;

      A = $random;
      B = $random;

      // Test every address
      for (i = 0; i < 8; i = i + 1) begin
         ADDR = i;
         #100;
         case (i)
         3'b001: if (O !== A) begin
                    $write("ERROR: %b at address %0d instead of %b\n",
                           O, i, A);
                    $write("Aborting.\n");
                    $finish;
                 end
         3'b101: if (O !== B) begin
                    $write("ERROR: %b at address %0d instead of %b\n",
                           O, i, B);
                    $write("Aborting.\n");
                    $finish;
                 end
         default: if (O !== 4'bzzzz) begin
                    $write("ERROR: %b at address %0d instead of %b\n",
                           O, i, 4'bzzzz);
                    $write("Aborting.\n");
                    $finish;
                 end
         endcase
      end
   end
   $write("Done.\n");
end

endmodule
