//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

module TEST_RFILE;

reg  [3:0] A, B;
wire [3:0] O;
reg  [3:0] ADDR;

RFILE DUT(A, B, ADDR, O);

integer i;
initial
begin

   A = $random;
   B = $random;

   // Test every address
   for (i = 0; i < 16; i = i + 1) begin
      ADDR = i;
      #100;
      case (i)
      4'b0001: if (O !== A) begin
                  $write("ERROR: %b at address %0d instead of %b\n",
                         O, i, A);
                  $write("Aborting.\n");
                  $finish;
               end
      4'b0110: if (O !== B) begin
                  $write("ERROR: %b at address %0d instead of %b\n",
                         O, i, B);
                  $write("Aborting.\n");
                  $finish;
               end
      default: if (O !== 4'bzzzz) begin
                 $write("ERROR: %b at address %0d instead of %b\n",
                        O, i, 4'bzzzz);
                 $write("Aborting.\n");
                 $finish;
              end
      endcase
   end
end

endmodule
