//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

module ROM(A, D, CS);

parameter
   DWIDTH   = 8,
   AWIDTH   = 3,
   STARTA   = 0,
   ENDA     = 15,
   BOOTFILE = "rom.dat";

input  [AWIDTH:1] A;
output [DWIDTH:1] D;
input             CS;

reg [DWIDTH:1] DATA [STARTA:ENDA];
reg [DWIDTH:1] Z;
integer i;

initial
begin
   $readmemh(BOOTFILE, DATA);
   // Can't use 'bz for DWIDTH > 32
   for (i = 1; i <= DWIDTH; i = i + 1) Z[i] = 1'bz;
end

assign D = (CS == 1'b1) ? DATA[A] : Z;

endmodule
