//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

`timescale 1ns/1ns
module TEST_ARBITER;

reg  RQ;
wire GT;

ARBITER DUT(RQ, GT);

initial
begin
   RQ = 1'b1;
   #100;

   // Test the arbiter
   RQ = 1'b0;
   fork: GRANT
      @ (negedge GT) disable GRANT;
      #100           disable GRANT;
   join
   if (GT !== 0) begin
      $write("ERROR: Grant not received.\n");
      $finish;
   end

   // Make sure grant signal stays stable
   fork: STABLE
      @ (GT) disable STABLE;
      #1000  disable STABLE;
   join
   if (GT !== 1'b0) begin
      $write("ERROR: Grant not stable.\n");
      $finish;
   end

   RQ = 1'b1;
   fork: UNGRANT
      @ (posedge GT) disable UNGRANT;
      #10            disable UNGRANT;
   join
   if (GT !== 1) begin
      $write("ERROR: Grant not removed.\n");
   end
  $finish;
end

endmodule
