//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

module DFF(D, CK, Q);
input  D, CK;
output Q;

reg Q;
time LAST_CK, LAST_D;

reg SEEN_1_CK;
initial SEEN_1_CK = 0;

always @ (posedge CK)
begin
   SEEN_1_CK = 1;
   Q <= #(1:3:4) D;
   LAST_CK = $time;
   if ($time - LAST_D < (2:3:4)) begin
      $write("Setup error (%m): %0d < %0d at %0d\n",
             $time - LAST_D, (2:3:4), $time);
   end
end

always @ (D)
begin
  LAST_D = $time;
  if (SEEN_1_CK && $time - LAST_CK < (3:4:5)) begin
     $write("Hold error (%m): %0d < %0d at %0d\n",
	    $time - LAST_CK, (3:4:5), $time);
  end
end

endmodule
