//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

module TEST_ADDER;

// Reg/wires required to connect the DUT
reg  [7:0] L, R;
wire [7:0] S;
wire       C;

// Device under test
ADDER8 DUT(.A(L), .B(R), .Ci(1'b0), .S(S), .Co(C));

// Test procedure
integer i,j;
initial
begin
    // Non-exhaustive test
    for (i = 0; i < 256; i = i + 13) begin
	for (j = 0; j < 256; j = j + 13) begin
	    L = i;
	    R = j;
	    #10;   // Prop delay through the adder
	    if ({C, S} !== L + R) begin
		$write("Adder is bad\n");
		$finish;
	    end
	end
    end
    // If we get here, no errors were found
    $write("Adder is good\n");
end

endmodule
