//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

`timescale 1ns/1ns
module RAM(A, WR, D, ADS, READY, CLK);

input  [7:0] A;
input        WR;
inout  [7:0] D;
input 	     ADS;
output 	     READY;
input 	CLK;

reg 	   READY;
reg [7:0]  STATUS, MASK, DATA;
assign D = DATA;

reg [7:0] MEM[0:255];

always
begin: i386
   DATA  <= #7 8'hZZ;
   READY <= #5 1'b1;

   
   // Phase 1
   @ (posedge CLK)
   if (ADS !== 1'b0) disable i386;
   // Phase 2
   @ (posedge CLK)
   if (ADS !== 1'b0) begin
      $write("ERROR: ADS not asserted during phase 2 at %t\n", $realtime);
   end
   // Phase 1
   @ (posedge CLK)
   if (ADS !== 1'b1) begin
      $write("ERROR: ADS not deasserted during phase 1 at %t\n", $realtime);
   end
   
   READY <= #5 1'b0;

   if (WR == 1'b1) begin
      // Write cycle
      @ (posedge CLK);
      MEM[A] = D;
   end
   else begin
      // Read cycle
      DATA <= #5 MEM[A];
      @ (posedge CLK);
   end
end

endmodule
