//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

`timescale 1ns / 1ns
module TEST_THING;

reg  [7:0] A;
reg 	   RW;
wire [7:0] D;
reg 	   ADS;
wire       RDY;
wire       INT;
reg 	   CLK;
reg 	   RST;

reg [7:0] DATA;
assign D = DATA;

`ifdef SST
initial $recordvars;
`endif

THING DUT(.A(A),
	  .WR(RW),
	  .D(D),
	  .ADS(ADS),
	  .READY(RDY),
	  .INT(INT),
	  .CLK(CLK),
	  .RST(RST));

//
// 16MHz clock
//
always
begin
   CLK = 1'b0;
   #31;
   CLK = 1'b1;
   #31;
end


// Monitor the interrupt output
always
begin
   wait (INT === 1'b1);
   $write("INT asserted at %0t\n", $realtime);
   wait (INT !== 1'b1);
end
 
initial
begin: TEST_PROCEDURE
   reg [2:0] SEEN;
   reg [7:0] TMP;

   $timeformat(-9, 3, " ns", 10);
   ADS  = 1'b1;
   DATA = 8'hZZ;
   SEEN = 3'b000;

   RST = 1'b1;
   repeat (4) @ (posedge CLK);
   RST = 1'b0;

   while (SEEN != 3'b111) begin
      wait (INT != 1'b0);

      READ(0, TMP);
      TMP = TMP & ~SEEN;

      if (TMP[2] == 1'b1) $write("A has been set\n");
      if (TMP[1] == 1'b1) $write("B has been set\n");
      if (TMP[0] == 1'b1) $write("C has been set\n");

      SEEN = SEEN | TMP;
      WRITE(1, SEEN);
   end

   $finish;   
end

//
// Read Cycle
//
task READ;
   input  [7:0] ADDR;
   output [7:0] RDAT;
begin
end
endtask

//
// Write Cycle
//
task WRITE;
   input [7:0] ADDR;
   input [7:0] WDAT;
begin
end
endtask


endmodule
