//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

module FSM(FRAME, CLK, RST);

input FRAME, CLK, RST;

parameter
   OUTSYNC = 2'b00,
   SYNCING = 2'b01,
   IN_SYNC = 2'b11,
   SYNCLSS = 2'b10;

reg [1:0] STATE;

always @ (posedge CLK)
begin
   if (RST) STATE <= OUTSYNC;
   else begin
      case (STATE)
      OUTSYNC: if (FRAME) STATE <= SYNCING;
      IN_SYNC: if (!FRAME) STATE <= SYNCLSS;
      default: STATE <= (FRAME) ? IN_SYNC : OUTSYNC;
      endcase
   end
end

endmodule
