//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

module TEST_FSM;

reg FRAME, CLK, RST;

FSM DUT(FRAME, CLK, RST);

always
begin
   CLK = 1'b0;
   #50;
   CLK = 1'b1;
   #50;
end

initial
begin
   FRAME = 0;
   RST = 1;
   repeat (2) @ (negedge CLK);
   RST = 0;
   repeat (2) @ (negedge CLK);
   FRAME = 1;
   repeat (4) @ (negedge CLK);
   FRAME = 0;
   repeat (1) @ (negedge CLK);
   FRAME = 1;
   repeat (2) @ (negedge CLK);
   FRAME = 0;
   repeat (3) @ (negedge CLK);
   FRAME = 1;
   repeat (1) @ (negedge CLK);
   FRAME = 0;
   repeat (2) @ (negedge CLK);
   FRAME = 1;
   repeat (5) @ (negedge CLK);
   FRAME = 1;
   repeat (5) @ (negedge CLK);
   RST = 1;
   repeat (2) @ (negedge CLK);
   RST = 0;
   repeat (5) @ (negedge CLK);
   $finish;
end

always @ (posedge CLK)
begin
   $write("State = %s\n", IMAGE(DUT.STATE));
end

function [7*8:1] IMAGE;
   input [1:0] STATE;
begin
   case (STATE)
   2'b00: IMAGE = "OUTSYNC";
   2'b01: IMAGE = "SYNCING";
   2'b11: IMAGE = "IN_SYNC";
   2'b10: IMAGE = "SYNCLSS";
   default: IMAGE = "???????";
   endcase
end
endfunction

endmodule
