#! /bin/sh -- # perl
eval 'exec perl -S $0 ${1+"$@"}'
    if 0;

#
# (c) Copyright 1996, Qualis Design Corporation
#     All rights reserved.
#
# Content of this file:
#	PERL hack to properly connect the FPGA pins from synthesis report
#
# Original Author:	Janick Bergeron, janick@qualis.com
#
# Filename:		$Source: /home/janick/qualis/training/vlog/labs/lab5.5/RCS/xc4005_84.pl,v $
# Current Revision:	$Revision: 1.1 $
# Last Updated:	$Date: 1997/09/25 00:24:41 $
# Last Modified by:	$Author: janick $
# Currently Locked by:	$Locker:  $
#
# Change History:
# $Log: xc4005_84.pl,v $
# Revision 1.1  1997/09/25 00:24:41  janick
# Initial revision
#
# Revision 1.1  1997/06/06 18:17:03  janick
# Initial revision
#
#

#
# This is a modification of a cut-and-paste from
# the LMG *.txt file
#
$pin{'A3'} = 80;
$pin{'A4'} = 81;
$pin{'A5'} = 82;
$pin{'A6'} = 83;
$pin{'A7'} = 84;
$pin{'A8'} = 3;
$pin{'A9'} = 4;
$pin{'A10'} = 5;
$pin{'A11'} = 6;
$pin{'A12'} = 7;
$pin{'A13'} = 8;
$pin{'A14'} = 9;
$pin{'A17'} = 14;
$pin{'CCLK'} = 73;
$pin{'CS0'} = 60;
$pin{'CS1_A2'} = 79;
$pin{'D0_DIN'} = 71;
$pin{'D1'} = 69;
$pin{'D2'} = 67;
$pin{'D3'} = 65;
$pin{'D4'} = 61;
$pin{'D5'} = 59;
$pin{'D6'} = 58;
$pin{'D7'} = 56;
$pin{'DONE'} = 53;
$pin{'ERR_INIT'} = 41;
$pin{'HDC'} = 36;
$pin{'LDC'} = 37;
$pin{'M0'} = 32;
$pin{'M1'} = 30;
$pin{'M2'} = 34;
$pin{'PAD37'} = 68;
$pin{'PAD43'} = 62;
$pin{'PAD58'} = 50;
$pin{'PAD61'} = 49;
$pin{'PAD62'} = 48;
$pin{'PAD65'} = 47;
$pin{'PAD66'} = 46;
$pin{'PAD69'} = 45;
$pin{'PAD70'} = 44;
$pin{'PAD72'} = 40;
$pin{'PAD75'} = 39;
$pin{'PAD76'} = 38;
$pin{'PAD86'} = 28;
$pin{'PAD90'} = 27;
$pin{'PAD93'} = 26;
$pin{'PAD94'} = 25;
$pin{'PAD97'} = 24;
$pin{'PAD98'} = 23;
$pin{'PAD99'} = 20;
$pin{'PAD100'} = 19;
$pin{'PAD103'} = 18;
$pin{'PGCK1_A16'} = 13;
$pin{'PGCK2'} = 35;
$pin{'PGCK3'} = 57;
$pin{'PGCK4_A1'} = 78;
$pin{'PROGRAM'} = 55;
$pin{'RDY_BUSY_RCLK'} = 70;
$pin{'RS'} = 66;
$pin{'SGCK1_A15'} = 10;
$pin{'SGCK2'} = 29;
$pin{'SGCK3'} = 51;
$pin{'SGCK4_DOUT'} = 72;
$pin{'TCK'} = 16;
$pin{'TDI'} = 15;
$pin{'TDO'} = 75;
$pin{'TMS'} = 17;
$pin{'WS_A0'} = 77;


#
# Look-up the connections from the PPR report
#
while (<>) {
    # format: "   P3                   : RST"
    if (m/^\s+P(\d+)\s+: (\S+)$/) {
	$to[$1] = $2;
    }
}


#
# Print the Verilog header
#
print <<HEADER;
`timescale 1ns/1ns
module THING(A, WR, D, ADS, READY, INT, CLK, RST);
input  [7:0] A;
input        WR;
inout  [7:0] D;
input 	     ADS;
output 	     READY;
output 	INT;
input 	CLK;
input 	RST;

//
// Interface to the LMC model
//
xc4005e_84 LMC(
HEADER

#
# Now print the verilog pin assignments
# in alphabetical order
#
$comma = 0;
foreach $pin (sort(keys(%pin))) {
    $_ = $to[$pin{$pin}];
    # Replace <x> with [x]
    s/</[/;
    s/>/]/;
    print ",\n" if $comma;
    print "\t.$pin\t($_)";
    $comma = 1;
}


#
# Complete the model
#
print <<TRAILER;
);
endmodule
TRAILER
