//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

`timescale 1 ns / 1 ns

module COMB(IN1, IN2, SEL, O);

input  IN1, IN2, SEL;
output O;

wire [0:1] DECODE;
reg AND1, AND2;
reg OUT;

assign #5 DECODE = (SEL) ? 2'b01 : 2'b10;

always @ (IN1 or IN2 or DECODE)
begin
   AND1 = IN1 & DECODE[0];
   AND2 = IN2 & DECODE[1];
   OUT  = AND1 | AND2;
end

assign O = OUT;

endmodule
