//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//
`timescale 1 ns / 1 ns

module TB;

reg	IN1, IN2, SEL;
wire	OUT;

COMB UUT(.IN1(IN1),
         .IN2(IN2),
         .SEL(SEL),
         .O  (OUT));

initial
begin: TEST_PROCEDURE
   reg [2:0] IN;
   integer   ERRORS;

   ERRORS = 0;
   IN     = 3'b000;
   repeat (8) begin
      {IN1, IN2, SEL} = IN;
      #100;
      if (OUT !== ((SEL) ? IN2 : IN1)) begin
         $write("Invalid output for IN1/IN2/SEL = %b/%b/%b: %b instead of %b\n",
                IN1, IN2, SEL, OUT, (SEL) ? IN2 : IN1);
         ERRORS = ERRORS + 1;
      end
      IN = IN + 1;
   end

   if (ERRORS > 0) $write("Your model has failed with %0d errors\n", ERRORS);
   else            $write("Your model has passed!\n");
end

endmodule
