//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

`timescale 1 ns / 1 ns

module TB;

reg	[1:0]	CODE;
wire	[3:0]	DECODE;

DECODER UUT(.CODE(CODE), .DECODE(DECODE));

initial
begin: TEST_PROCEDURE

    reg	[5:0]	VECTOR;
    reg	[5:0]	VECTORS	[3:0];
    integer	ERRORS;
    integer	i;
    
    VECTORS[0] = {2'b01, 4'b0010};
    VECTORS[1] = {2'b00, 4'b0001};
    VECTORS[2] = {2'b11, 4'b1000};
    VECTORS[3] = {2'b10, 4'b0100};

    ERRORS = 0;
    repeat (2) begin
        for (i = 0; i < 4; i = i + 1) begin
            VECTOR = VECTORS[i];
            CODE = VECTOR[5:4];
            $write("Testing decoding of 'b%b...\n", CODE);
            #100;
            if (DECODE !== VECTOR[3:0]) begin
                $write("* ERROR * Decoded value of 'b%b is 'b%b instead of 'b%b\n",
                       CODE, DECODE, VECTOR[3:0]);
                ERRORS = ERRORS + 1;
            end
        end
    end
    
    if (ERRORS > 0) $write("Your model has failed with %0d errors\n", ERRORS);
    else $write("Your model has passed!\n");
end
endmodule
