//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

module BIT_COUNT(VECTOR, COUNT, BYTE);

input	[31:0]	VECTOR;
output	[ 5:0]	COUNT;
output  [ 3:0]  BYTE;

reg	[ 5:0]	COUNT;
reg     [ 3:0]  BYTE;

always @ (VECTOR)
begin: COUNT_BITS
   integer i;

   COUNT = 6'h00;
   for (i = 0; i < 32;  i = i + 1) begin
      COUNT = COUNT + VECTOR[i];
   end

   BYTE[0] = |VECTOR[ 7: 0];
   BYTE[1] = |VECTOR[15: 8];
   BYTE[2] = |VECTOR[23:16];
   BYTE[3] = |VECTOR[31:24];
end

endmodule
