//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

module TB;

reg	[31:0]	I;
wire	[5:0]	C;
wire    [3:0]   B;

BIT_COUNT UUT(I, C, B);

initial
begin: TEST_PROCEDURE
    integer	ERRORS;
    
    ERRORS = 0;
    
    $write("Testing bit counter with 128 random vectors\n");
    repeat (128) begin: TEST_ONE
        integer	CNT;
       reg [3:0] BYTE;
        integer	i;
        
        I = $random;
        CNT = 0;
        for (i = 0; i < 32; i = i + 1) begin
            if (I[i] == 1'b1) CNT = CNT + 1;
        end
       
        BYTE[0] = |I[ 7: 0];
        BYTE[1] = |I[15: 8];
        BYTE[2] = |I[23:16];
        BYTE[3] = |I[31:24];
        
        #100;
        
        if (C !== CNT) begin
            $write("* ERROR * 'b%b has %0d 1s instead of %0d\n",
                   I, CNT, C);
            ERRORS = ERRORS + 1;
        end
        if (B !== BYTE) begin
            $write("* ERROR * 'b%b has %b byte enabled instead of %b\n",
                   I, BYTE, B);
            ERRORS = ERRORS + 1;
        end
    end
    
    if (ERRORS > 0) $write("Your model has failed with %0d errors\n", ERRORS);
    else $write("Your model has passed!\n");
end

endmodule
