//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

//
// Solution from Marianne Lundstrom and    B. John Rask
//                 Nortel (Ottawa)      Credence (Beaverton)
//
// Verilog class, 960328
//

`timescale 1 ns / 1 ns

module RT_LF_SHIFT(I, LD, RT, LF, CK, RST, O);

input	[3:0]	I;
input		LD;
input		RT;
input		LF;
input		CK;
input		RST;
output	[3:0]	O;

reg [3:0] O;

//
// Please specify a synthesizable description of a loadable
// left/right logical shifter with synchronous reset, active at
// the rising edge of the clock.  All control signals are active
// high and are guaranteed not to be high at the same time.
// 


always @(posedge CK)
begin
	if (RST == 1) O <= 4'b0000;
	else
	case (1'b1)
	// synopsys parallel_case
		LD  : O <= I;
		RT  : begin
				O[3] <= 1'b0;
  				O[2] <= O[3];
				O[1] <= O[2];
				O[0] <= O[1];
			  end
		LF  : begin
				O[0] <= 1'b0;
  				O[1] <= O[0];
				O[2] <= O[1];
				O[3] <= O[2];
			  end
	endcase
end
				
endmodule
