//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

`timescale 1 ns / 1 ns

module GRAY_COUNT(CK, CNT, RST);

input		CK;
output	[2:0]	CNT;
input		RST;

reg	[2:0]	CNT;
//
// Please specify a synthesizable description of a 3-bit gray counter
// with asynchronous active high reset. The counter is active on the
// rising clock edge.
// 
// A gray counter is a counter whose successive output values differ
// only by one 1 bit (e.g. 10, 11, 01, 00, 10, ...)
// 

	always @(posedge CK or posedge RST) begin
		if (RST == 1'b1) begin
			CNT <= 3'b000;
		end
		else begin
			case (CNT)
				3'b000 :	CNT <= 3'b001;
				3'b001 :	CNT <= 3'b011;
				3'b011 :	CNT <= 3'b010;
				3'b010 :	CNT <= 3'b110;
				3'b110 :	CNT <= 3'b111;
				3'b111 :	CNT <= 3'b101;
				3'b101 :	CNT <= 3'b100;
				3'b100 :	CNT <= 3'b000;
			endcase
		end
	end
endmodule
