//
//	Copyright (c) 2009 HDL Express.
//	All rights reserved.
//
//	E-mail: verilog@hdlexpress.com
//	World Wide Web: http://www.hdlexpress.com	
//

`timescale 1 ns / 1 ns

module FIFO(DI, CKI, DO, CKO, FULL, MT, RST);

input	[7:0]	DI;
input		CKI;
output	[7:0]	DO;
input		CKO;
output		FULL;
output		MT;
input		RST;

//
// Please specify a synthesizable description of an asynchronously
// resettable 3-deep FIFO.
// Words are written at the rising edge of CKI and are consumed
// at the rising edge of CKO.
// The outputs FULL and MT are asserted high when the FIFO is full
// and empty respectively.
//
// On reset, the content of the FIFO need not be reset.
// A user writing to an already full FIFO or reading from an empty
// FIFO deserves the unexpected results he will get.
// 

endmodule
